# 3.5.1. builder

resource type: builder
  Attributes:

    - builderid (integer) – the ID of this builder

    - description? (string) – The description for that builder

    - masterids[] (integer) – the ID of the masters this builder is running on

    - name (string) – builder name

    - tags[] (string) – list of tags for this builder

    - projectid? (string) – the ID of the project that this builder is associated with, if any

This resource type describes a builder.

## 3.5.1.1. Update Methods

All update methods are available as attributes of `master.data.updates`.

class buildbot.data.builders.Builder
  updateBuilderList(masterid, builderNames)
    Parameters:

      - masterid (integer) – this master’s master ID

      - builderNames (list) – list of names of currently-configured builders (unicode strings)

    Returns:

      Deferred

    Record the given builders as the currently-configured set of builders on this master. Masters should call this every time the list of configured builders changes.

## 3.5.1.2. Endpoints

path: /builders

This path selects all builders

`GET`
  `returns`

    `collection` of `builder`

path: /builders/{builderid_or_buildername}
  Path Keys:

    builderid_or_buildername (number|string) – the ID or name of the builder

This path selects a builder by builderid

`GET`
  `returns`

    `collection` of `builder`

path: /masters/{masterid}/builders
  Path Keys:

    masterid (number) – the id of the master

This path selects all builders of a given master

`GET`
  `returns`

    `collection` of `builder`

path: /masters/{masterid}/builders/{builderid}
  Path Keys:

    - masterid (number) – the id of the master

    - builderid (number) – the id of the builder

This path selects one builder by id of a given master

`GET`
  `returns`

    `collection` of `builder`

path: /projects/{projectid_or_projectname}/builders
  Path Keys:

    projectid_or_projectname (number|identifier) – the ID or name of the project

This path selects all builders for a project

`GET`
  `returns`

    `collection` of `builder`